from odoo import api, fields, models
from odoo.tools import index_exists


class AccRepartitionCounter(models.Model):
    _name = "acc.repartition.counter"
    _description = "Priorité par compteur"

    acc_repartition_id = fields.Many2one("acc.repartition.keys", "Clé", required=True)
    weight = fields.Float(string="Répartition en pourcentage", required=False)
    time_slot = fields.Datetime("Horodatage de la clé", required=True)
    acc_counter_id = fields.Many2one("acc.counter", string="Compteur", required=True)
    acc_operation_id = fields.Many2one(
        comodel_name="acc.operation", compute="_compute_operation_id", store=True
    )

    def init(self):
        super().init()
        if not index_exists(self._cr, "acc_repartition_counter_index"):
            self._cr.execute(
                """
                CREATE INDEX acc_repartition_counter_index
                ON
                    acc_repartition_counter (time_slot, acc_counter_id)

                """
            )

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------
    @api.depends("acc_repartition_id")
    def _compute_operation_id(self):
        for key in self:
            key.acc_operation_id = key.acc_repartition_id.operation_id

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------
